XIncludeFile "vsm.pbi"

Macro mClassPrivate
  
  ;    IACTIVEMODEL.
  *component.ICOMPONENT
  *instance.IINSTANCE
  
  ;    IDSIMMODEL.
  *inst.IINSTANCE
  *ckt.IDSIMCKT
  
  *PinR.IDSIMPIN
  *PinG.IDSIMPIN
  *PinB.IDSIMPIN
  *PinGND.IDSIMPIN
  
  ;   .
  Color.l
  new_flag.b 
  
EndMacro

Structure Class_IDSIM
  *vt[1] ;pointer to virtual table as first entry.
  
  mClassPrivate ;  .
EndStructure 

Structure Class_IACTIVE
  *vt[2] ;pointer to virtual table as first entry.
  
  mClassPrivate ;  .
EndStructure 

EnableExplicit
EnableASM

Declare ModelNEW()
Declare animate(element.i, *newstate.ACTIVEDATA)

ProcedureCDLL.i createactivemodel(device.s, *ils.ILICENCESERVER)
  Protected *Result=0
  
  If *ils\Authorize($80808081)
    *Result=ModelNEW() ;  .
  EndIf
  
  ProcedureReturn *Result
EndProcedure

ProcedureCDLL deleteactivemodel(*model.Class_IACTIVE)
  If *model
    ;ClearStructure(*model, Class_IACTIVE)
    FreeMemory(*model) ;  ,  .
  EndIf
EndProcedure

Procedure ModelNEW()   ;  .
  Protected *Class.Class_IACTIVE=0
  
  *Class = AllocateMemory(SizeOf(Class_IACTIVE)) 
  If *Class
    ;InitializeStructure(*Class, Class_IACTIVE)
    *Class\vt[0] = ?IACTIVE_Funct ;   IACTIVEMODEL.
    *Class\vt[1] = ?IDS_Funct     ;   IDSIMMODEL.
  EndIf   
  
  ProcedureReturn *Class 
EndProcedure

;-   
;{

;- IACTIVEMODEL.

;  .
;        IComponent.
Procedure initialize(*cpt.ICOMPONENT)
  Protected *This.Class_IACTIVE, s.s, c.l, i
  MOV *This, ecx
  
  *This\component = *cpt
  
  *This\new_flag = #True
  *This\Color = 0
 
EndProcedure

; ISIS   ,    .
;      .
; ,       "PRIMITIVE=.ANALOG.ammeter",
;      "AMMETER".
Procedure.i getspicemodel(*sPrimitive)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  ProcedureReturn 0 ;    .
EndProcedure
  
;   ,  ISIS   ,
;    .
; ,     "PRIMITIVE=.DIGITAL.display",
;       "DISPLAY".
Procedure.i getdsimmodel(*sPrimitive)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  ProcedureReturn *This+SizeOf(Integer) ;    IDSIMMODEL.
EndProcedure

;   ,      ().
;     animate()     ,
;  ,   .
;  ,       .
;    : *This\component\drawstate(state).
Procedure Plot_IACTIVE(state.ACTIVESTATE)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  *This\component\drawstate(state)
  *This\new_flag = #True
  MOV ecx, *This ; Thiscall .
  animate(0, 0)  ;     .
EndProcedure

;     ,    ,
; ( ISPICEMODEL  IDSIMMODEL)    .
;     PROSPICE  
;    IDSIMMODEL\indicate(),
;      .
;    ,   
;        .
;    ,    
;  RTVPROBE, RTIPROBE  RTDPROBE  ,   
; ,       .
;  "element" -   ,    .
;       RTxPROBE,
;      ,     .
;  *newstate    .
Procedure animate(element.i, *newstate.ACTIVEDATA)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  If *This\new_flag = #True ;     .
    *This\new_flag = #False
    *This\component\setbrushcolour(*This\Color)  ;  .
    *This\component\drawcircle(500, -500, 300)   ;  .
  EndIf
  
EndProcedure

;       ,
;         .
;           ().
;     #True,  ,   "" 
;       ,    #False.
;  : key -    Windows,
;    -        ,
; flags -    : 1 - , 2 - .
Procedure.b actuate_IACTIVE(key.w, x.i, y.i, flags.l)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  ProcedureReturn #False
EndProcedure


;- IDSIMMODEL.

;  isdigital.
;    1,       ,  0,  .
;     ,  ,     1.
Procedure isdigital(*PinName)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
  ProcedureReturn 1 ;     .
EndProcedure

;  setup.
;     IINSTANCE   ,
;  IDSIMCKT   . 
;        , 
;        IINSTANCE  IDSIMCKT.
; ,         
; (   *This\inst\getdsimpin).
Procedure setup(*instance.IINSTANCE, *dsimckt.IDSIMCKT)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
  *This\inst = *instance ;    .
  *This\ckt  = *dsimckt
  
  ;     .
  *This\PinR = *This\inst\getdsimpin("R", #True)
  *This\PinG = *This\inst\getdsimpin("G", #True)
  *This\PinB = *This\inst\getdsimpin("B", #True)
  *This\PinGND = *This\inst\getdsimpin("GND", #True)
  
EndProcedure

;  runctl       ,
;     .
;    ,    
;     .
Procedure runctrl(mode.RUNMODES)
  Protected *This.Class_IDSIM
  MOV *This, ecx
EndProcedure

;  actuate ,         
;   .      /  /. 
Procedure actuate_IDS(time.REALTIME, newstate.ACTIVESTATE)
  Protected *This.Class_IDSIM
  MOV *This, ecx
EndProcedure

;  indicate      .
;     FALSE,       .
Procedure indicate(time.REALTIME,  *aData.ACTIVEDATA)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
  ProcedureReturn #True
EndProcedure

;  simulate      .
;            ,
;     ,   -     .
Procedure simulate(time.ABSTIME, mode.DSIMMODES)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
  ;          .
  *This\Color = RGB(ishigh(*This\PinR\istate())*255,
                    ishigh(*This\PinG\istate())*255, 
                    ishigh(*This\PinB\istate())*255)
  *This\new_flag = #True
  
EndProcedure

;  callback     ,
;    IDSIMCKT::setcallback. Ÿ     .
Procedure callback(time.ABSTIME, eventid.EVENTID)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
EndProcedure


DataSection
  
  IACTIVE_Funct:
  Data.i @initialize()
  Data.i @getspicemodel()
  Data.i @getdsimmodel()
  Data.i @Plot_IACTIVE()
  Data.i @animate()
  Data.i @actuate_IACTIVE()
  IDS_Funct:
  Data.i @isdigital()
  Data.i @setup()
  Data.i @runctrl()
  Data.i @actuate_IDS()
  Data.i @indicate()
  Data.i @simulate()
  Data.i @callback()
  
EndDataSection

;}
; IDE Options = PureBasic 5.11 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 0
; FirstLine = 0
; Folding = ----
; EnableAsm
; Executable = Led_3Color.dll
; IncludeVersionInfo
; VersionField0 = 1.0.0.0
; VersionField1 = 1.0.0.0
; VersionField2 = purebasic.mybb.ru
; VersionField3 = DigitalLed
; VersionField4 = 1.0
; VersionField5 = 1.0
; VersionField6 =     Proteus
; VersionField7 = DigitalLed
; VersionField8 = %EXECUTABLE
; VersionField9 = ϸ
; VersionField13 = pure-basic@yandex.ru
; VersionField14 = purebasic.mybb.ru
; VersionField16 = VFT_DLL