XIncludeFile "vsm.pbi"

Structure PinParam
  *Pin.IDSIMPIN
  OldState.b
  OldTime.ABSTIME[2]
  Color.a
EndStructure

Macro mClassPrivate
  ;    IACTIVEMODEL.
  *component.ICOMPONENT
  *instance.IINSTANCE
  
  ;    IDSIMMODEL.
  *inst.IINSTANCE
  *ckt.IDSIMCKT
  
  PinR.PinParam
  PinG.PinParam
  PinB.PinParam
  PinGND.PinParam
  
  ;   .
  Color.l
  new_flag.b 
  
EndMacro

Structure Class_IDSIM
  *vt_IDSIM ;pointer to virtual table as first entry.
  
  mClassPrivate ;  .
EndStructure 

Structure Class_IACTIVE
  *vt_IACTIVE ;pointer to virtual table as first entry.
  *vt_IDSIM
  
  mClassPrivate ;  .
EndStructure 

EnableExplicit
EnableASM

Declare ModelNEW()
Declare animate(element.i, *newstate.ACTIVEDATA)

ProcedureCDLL.i createactivemodel(device.s, *ils.ILICENCESERVER)
  Protected *Result=0
  
  If *ils\Authorize($80808081)
    *Result=ModelNEW() ;  .
  EndIf
  
  ProcedureReturn *Result
EndProcedure

ProcedureCDLL deleteactivemodel(*model.Class_IACTIVE)
  If *model
    ;ClearStructure(*model, Class_IACTIVE)
    FreeMemory(*model) ;  ,  .
  EndIf
EndProcedure

Procedure ModelNEW()   ;  .
  Protected *Class.Class_IACTIVE=0
  
  *Class = AllocateMemory(SizeOf(Class_IACTIVE)) 
  If *Class
    ;InitializeStructure(*Class, Class_IACTIVE)
    *Class\vt_IACTIVE = ?IACTIVE_Funct ;   IACTIVEMODEL.
    *Class\vt_IDSIM   = ?IDS_Funct     ;   IDSIMMODEL.
  EndIf   
  
  ProcedureReturn *Class 
EndProcedure

Procedure PinColor(*This.Class_IDSIM, *Pin.PinParam, time.ABSTIME)
  Protected Temp.f
  Protected st.b = ishigh(*Pin\Pin\istate())
  
  ;      ,  .
  ;     ,  .
  If *Pin\OldTime[0] = 0
    *Pin\OldState = st
    *Pin\OldTime[0] = time
    *Pin\OldTime[1] = time
    ProcedureReturn
  EndIf
    
  ;      100  -   .
  If (time - *Pin\OldTime[0]) / 100000000000 > 0
    If st
      *Pin\Color=255
    Else
      *Pin\Color=0
    EndIf
    *Pin\OldTime[0]=time
    *Pin\OldTime[1]=time
    *Pin\OldState = st
    ProcedureReturn
  EndIf
  
  ;      ,  .
  If *Pin\OldState = st
    ProcedureReturn
  EndIf
    
  If st=0 ;  .
    If *Pin\OldTime[0] = *Pin\OldTime[1] ;   .
      *Pin\OldTime[0]=time
    Else ;   .
      
      ;       0...255.
      Temp = 255/(((Time-*Pin\OldTime[0]) / (Time-*Pin\OldTime[1])))
      If Temp>255
        *Pin\Color = 255
      ElseIf Temp<0
        *Pin\Color = 0
      Else
        *Pin\Color = Int(Temp)
      EndIf
      
      *Pin\OldTime[0]=time ;   .
      *Pin\OldTime[1]=time
    EndIf
    
  Else ;  
    *Pin\OldTime[1]=time ;    .
  EndIf
  
  *Pin\OldState = st
EndProcedure

;-   
;{

;- IACTIVEMODEL.

;  .
;        IComponent.
Procedure initialize(*cpt.ICOMPONENT)
  Protected *This.Class_IACTIVE, s.s, c.l, i
  MOV *This, ecx
  
  *This\component = *cpt
  *This\new_flag = #True
  *This\Color = $7F7F7F
  
EndProcedure

; ISIS   ,    .
;      .
; ,       "PRIMITIVE=.ANALOG.ammeter",
;      "AMMETER".
Procedure.i getspicemodel(*sPrimitive)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  ProcedureReturn 0 ;    .
EndProcedure

;   ,  ISIS   ,
;    .
; ,     "PRIMITIVE=.DIGITAL.display",
;       "DISPLAY".
Procedure.i getdsimmodel(*sPrimitive)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  ProcedureReturn *This+OffsetOf(Class_IACTIVE\vt_IDSIM);SizeOf(Integer) ;    IDSIMMODEL.
EndProcedure

;   ,      ().
;     animate()     ,
;  ,   .
;  ,       .
;    : *This\component\drawstate(state).
Procedure Plot_IACTIVE(state.ACTIVESTATE)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  *This\component\drawstate(state)
  *This\new_flag = #True
  
  MOV ecx, *This ; Thiscall .
  animate(0, 0)  ;     .
  
EndProcedure

;     ,    ,
; ( ISPICEMODEL  IDSIMMODEL)    .
;     PROSPICE  
;    IDSIMMODEL\indicate(),
;      .
;    ,   
;        .
;    ,    
;  RTVPROBE, RTIPROBE  RTDPROBE  ,   
; ,       .
;  "element" -   ,    .
;       RTxPROBE,
;      ,     .
;  *newstate    .
Procedure animate(element.i, *newstate.ACTIVEDATA)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  If *This\new_flag = #True ;     .
    *This\new_flag = #False
    *This\component\setbrushcolour(*This\Color)  ;  .
    *This\component\drawcircle(500, -500, 300)   ;  .
  EndIf
  
EndProcedure

;       ,
;         .
;           ().
;     #True,  ,   "" 
;       ,    #False.
;  : key -    Windows,
;    -        ,
; flags -    : 1 - , 2 - .
Procedure.b actuate_IACTIVE(key.w, x.i, y.i, flags.l)
  Protected *This.Class_IACTIVE
  MOV *This, ecx
  
  ProcedureReturn #False
EndProcedure


;- IDSIMMODEL.

;  isdigital.
;    1,       ,  0,  .
;     ,  ,     1.
Procedure isdigital(*PinName)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
  ProcedureReturn 1 ;     .
EndProcedure

;  setup.
;     IINSTANCE   ,
;  IDSIMCKT   . 
;        , 
;        IINSTANCE  IDSIMCKT.
; ,         
; (   *This\inst\getdsimpin).
Procedure setup(*instance.IINSTANCE, *dsimckt.IDSIMCKT)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
  *This\inst = *instance ;    .
  *This\ckt  = *dsimckt
  
  ;     .
  *This\PinR\Pin = *This\inst\getdsimpin("R", #True)
  *This\PinG\Pin = *This\inst\getdsimpin("G", #True)
  *This\PinB\Pin = *This\inst\getdsimpin("B", #True)
  *This\PinGND\Pin = *This\inst\getdsimpin("GND", #True)
  
  *This\ckt\setcallback(20000000000, *This, $20)
EndProcedure

;  runctl       ,
;     .
;    ,    
;     .
Procedure runctrl(mode.RUNMODES)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
EndProcedure

;  actuate ,         
;   .      /  /. 
Procedure actuate_IDS(time.REALTIME, newstate.ACTIVESTATE)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
EndProcedure

;  indicate      .
;     FALSE,       .
Procedure indicate(time.REALTIME,  *aData.ACTIVEDATA)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
  If *This\new_flag = #True
    *aData\Type = #ADT_DSIMDATA
    *aData\dsimdata\numpins=4
  EndIf
  
  ProcedureReturn #True
EndProcedure

;  simulate      .
;            ,
;     ,   -     .
Procedure simulate(time.ABSTIME, mode.DSIMMODES)
  Protected *This.Class_IDSIM
  MOV *This, ecx
  
  PinColor(*This, *This\PinR, time)
  PinColor(*This, *This\PinG, time)
  PinColor(*This, *This\PinB, time)
  
  *This\Color = RGB(*This\PinR\Color,
                    *This\PinG\Color, 
                    *This\PinB\Color)
  
  *This\new_flag = #True
EndProcedure

;  callback     ,
;    *This\ckt\setcallback(). Ÿ     .
Procedure callback(time.ABSTIME, eventid.EVENTID)
  Protected *This.Class_IDSIM, *x
  MOV *This, ecx
  
  If eventid=$20
    PinColor(*This, *This\PinR, time)
    PinColor(*This, *This\PinG, time)
    PinColor(*This, *This\PinB, time)
    
    *This\Color = RGB(*This\PinR\Color,
                      *This\PinG\Color, 
                      *This\PinB\Color)
    *This\new_flag = #True
    
    ;  .  0.2     setcallback()   $20.
    *This\ckt\setcallback(time+200000000000, *This, $20)
  EndIf
EndProcedure

DataSection
  IACTIVE_Funct:
  Data.i @initialize()
  Data.i @getspicemodel()
  Data.i @getdsimmodel()
  Data.i @Plot_IACTIVE()
  Data.i @animate()
  Data.i @actuate_IACTIVE()
  IDS_Funct:
  Data.i @isdigital()
  Data.i @setup()
  Data.i @runctrl()
  Data.i @actuate_IDS()
  Data.i @indicate()
  Data.i @simulate()
  Data.i @callback()
EndDataSection

;}
; IDE Options = PureBasic 5.11 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 0
; FirstLine = 0
; Folding = ----
; EnableAsm
; Executable = Led_3Color.dll
; IncludeVersionInfo
; VersionField0 = 1.0.0.0
; VersionField1 = 1.0.0.0
; VersionField2 = purebasic.mybb.ru
; VersionField3 = DigitalLed PWM
; VersionField4 = 1.0
; VersionField5 = 1.0
; VersionField6 =    (PWM)  Proteus
; VersionField7 = DigitalLed PWM
; VersionField8 = %EXECUTABLE
; VersionField9 = ϸ
; VersionField11 =  (  - 10 ).
; VersionField13 = pure-basic@yandex.ru
; VersionField14 = purebasic.mybb.ru
; VersionField16 = VFT_DLL